<!--
Project: Content Management System.
Component: Writer (File 4 of 5).
Filename: "process_asset_metadata.php".
Purpose: Checks metadata for errors and then writes out metadata to a temporary file.
-->

<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
	<title> Simple Content Management System </title>
</head>

<body>

<h1>Simple Content Management System</h1>
<h2>Step 2b: Metadata Results Page</h2>

<?php
/* 
The $bufferFilename variable is used to store the name of the temporary file we will be writing to. For this exercise, this file needs to be in the same directory as this script, but it could be changed by including the directory path as part of this variable.
*/
$bufferFilename = "metadata_buffer.txt";

/*
The first thing we will do is to grab the various characteristics of our asset from the form.
*/
$assetId = $_POST["asset_id"];
$assetFilename = $_POST["asset_filename"];
$assetName = $_POST["asset_name"];
$assetMediaType = $_POST["asset_media_type"];
$assetDescription = $_POST["asset_description"];
$assetCategory = $_POST["asset_category"][0];
$assetYearsUsed = $_POST["asset_years_used"][0];

/*
Next, we need to make sure these variables all contain data.  If not, we provide a link back to the previous page and ask the user to enter data for all fields.  The $errors variable will keep track of total errors and if this variable is greater than zero, the user will be asked to go back and provide any missing data.
*/

/* If the asset ID is missing, show an error message. */
if (empty($assetId))
	{
	echo "Asset id is missing!<br />";
	$errors++;
	}

/* If the asset name is missing, show an error message. */
if (empty($assetName))
	{
	echo "Asset name is required!<br />";
	$errors++;
	}

/* If the asset filename is missing, show an error message. */
if (empty($assetFilename))
	{
	echo "Asset filename is required!<br />";
	$errors++;
	}

/* If the asset category is missing, show an error message. */
if (empty($assetCategory))
	{
	echo "Asset category is required!<br />";
	$errors++;
	}
else
	/* Otherwise, loop through and add a comma to separate each category */
	{
	foreach($_POST["asset_category"] as $cat)
		{
		if (empty($temp))
			$temp = $cat;
		else
			$temp = $temp.", ".$cat;
		}
	}

$assetCategory = $temp;

/* If no years are selected, show an error message. */
if (empty($assetYearsUsed))
	{
	echo "Asset year is required!<br />";
	$errors++;
	}
else
	/* Otherwise, loop through and add a comma to separate each year used */
	{
	foreach($_POST["asset_years_used"] as $year)
		{
		if (empty($temp2))
			$temp2 = $year;
		else
			$temp2 .= ", ".$year;
		}
	}

$assetYearsUsed = $temp2;

/* If the asset media type is missing, show an error message. */
if (empty($assetMediaType))
	{
	echo "Asset media type is required!<br />";
	$errors++;
	}

/* If the asset description is missing, show an error message. */
if (empty($assetDescription))
	{
	echo "Asset description is required!<br />";
	$errors++;
	}

/* 
Here is the part where we check the total errors and redirect the user if need be.
*/
if ($errors > 0)
	{
	echo "There were one or more errors with your data.<br />";
	echo "Please <a href=\"javascript:history.back()\">go back</a> button and correct your input!<br />";
	}
else
	{ 

	/*
	What we are going to do now is to "glue" the variables together	into a single line using the PHP concatenation operator, 
	which is the period (.)  In order to keep each variable distinct, we will use the character sequence *** to separate each entry.
	Also, a \n (newline escape sequence) is used to make each additional entry begin on a new line.
	*/
	$gluedString = $assetId."***".$assetFilename."***".$assetName."***".$assetCategory."***".$assetYearsUsed."***".$assetMediaType."***".$assetDescription."\n";

	/* 
	Now, we create a connection to the second buffer text file; the first argument is the filename and the second argument is the "mode". "a" mode means "append" and new text content		will be added to the end of the file.	$fp is a variable that holds		the "link" or connection to the file that we open and then sends this link to the fwrite function for the purpose of writing data to the file. 
	*/

	if ($fp = fopen($bufferFilename,"a"))
		{
		/* This will write the glued string to the file */
		if (fwrite($fp, $gluedString))
			{
			echo "Asset added to buffer file!<br />";
			/* This closes the file after the writing is done */
			fclose($fp); 
			}
		else
			/* This is displayed if the file cannot be written to */
			{
			echo "There was an error adding your asset.<br />";
			echo "Please check the file permissions for your buffer file.<br />";
			echo "The buffer filename is: ".$bufferFilename.".<br />";
			}
		}
	else
		{
		echo "Unable to open asset metadata file!";
		}
	}

?>

<p>Click here to return to Step 1 and <a href="upload_asset.html">add another asset</a>.</p>

<p>Click here to proceed to Step 3 and <a href="finalize_assets.php">finalize all assets</a> by writing them to an XML file.</p>

</body>
</html>

<!-- End of "process_asset_metadata.php" file -->